/**************************************************************************
*
* Nom du projet     : Gauss
* Objet 				  : Rsolution d'un systme linaire  n quations
*							  n inconnues. Module interface utilisateur
*
***************************************************************************
*
* Rpertoire                : gauss\bin
* Nom du fichier            : gauss.c
* Nom du fichier d'analyse  : suivi/suivi.doc
* Auteur                    : Igor APARICI - David ROUSSE
* Date de creation          : 06 / 12 /1999
* Date de mise a jour       :
* Valide par                : David ROUSSE
* Date de validation        : 13 / 01 / 2000
* Indice du module          : 2
*
***************************************************************************
*
***************************************************************************
************************ MODIFICATIONS APPORTEES **************************
*
* Le :10 / 01 / 2000             Indice : 1
* Origine et Descriptif de la modification :
*	- Libration de la mmoire
*
***************************************************************************
* Le :13 / 01 / 2000             Indice : 2
* Origine et Descriptif de la modification :
*	- Option de nouvelle lecture des donnes sur disque
*
***************************************************************************
*/

#include <stdio.h>
#include <ctype.h>
#include <conio.h>
#include <time.h>
#include "perso.h"

main()
{
   char nomfichier[51];
	int choix=1, taillesysteme, determinant=-1, rang=-1, calculinverse=-1;
   int resultat, sortiefichier=0;
   double **premiermembre, *secondmembre, *vecteursolution, **matriceinverse;
   clock_t tdebut, tfin;
   FILE *fp;

   /* message de dbut */
   messagedebut();

   /* lecture de la taille du systme  rsoudre */
   taillesysteme = lecturetaille(nomfichier);

   /* allocation dynamique de memoire */
   premiermembre = allouermat(taillesysteme);
   secondmembre = allouervect(taillesysteme);
   vecteursolution = allouervect(taillesysteme);
   matriceinverse = allouermat(taillesysteme);

   /* lecture des donnees */
   lecturedonnees(premiermembre,secondmembre,taillesysteme,nomfichier);

	/* boucle permettant  l'utilisateur de choisir les options du menu */
	do
   {
      /* lecture du choix du menu */
      do
      {
	      menu(); /* affichage du menu */
      	fflush(stdin); /* vide le tampon */
      }
     	while(scanf("%d",&choix)!=1); /* on ne lit qu'un entier */

		switch(choix)
		{
         case 0:
         	/* fin du programme */
            break;
  		 	case 1:
         	/* methode du pivot total */
       		clrscr();
            printf("\n Resolution du systeme par la methode ");
            printf("du PIVOT TOTAL ...\n");

            resultat = pivottot(premiermembre,secondmembre,vecteursolution,
            								taillesysteme);

            if(resultat)
            {
            	/* affichage du rsultat */
            	printf("\n Solution du systeme :\n");
            	affichervect(vecteursolution,taillesysteme);
               if(sortiefichier)
               {
               	/* ecriture des resultats dans un fichier */
               	printf("\n\n Ecriture des resultats sur le disque ...\n");
               	fp = recuperernomfic("max.txt");
               	ecriremessage("Resolution par la methode du pivot maximal\n",fp);
 		         	ecriremessage("Premier membre:",fp);
      	      	ecriremat(premiermembre,taillesysteme,fp);
         	   	ecriremessage("Second membre:",fp);
            		ecrirevect(secondmembre,taillesysteme,fp);
   			   	ecriremessage("Vecteur solution:",fp);
            		ecrirevect(vecteursolution,taillesysteme,fp);
                  ecriremessage("\nFichier genere par gauss.exe - ",fp);
                  ecriremessage("David ROUSSE, Igor APARICI -",fp);
               	fclose(fp);
            	}
            }
            else /* le systeme n'a pas de solution */
            	printf("\n !!! Le systeme n'a pas de solution !!!\n");

            attendre();
   		  	break;
       	case 2:
         	/* methode du pivot de Jordan-Gauss */
       		clrscr();
            printf("\n Resolution du systeme par la methode ");
            printf("du PIVOT de JORDAN-GAUSS ...\n");

            resultat = pivotgauss(premiermembre,secondmembre,vecteursolution,
            								taillesysteme);

            if(resultat)
            {
            	/* affichage du rsultat */
            	printf("\n Solution du systeme :\n");
            	affichervect(vecteursolution,taillesysteme);
               if(sortiefichier)
               {
               	/* ecriture des resultats dans un fichier */
               	printf("\n\n Ecriture des resultats sur le disque ...\n");
               	fp = recuperernomfic("gauss.txt");
               	ecriremessage("Resolution par la methode du pivot ",fp);
                  ecriremessage("de Jordan-Gauss \n",fp);
 		         	ecriremessage("Premier membre:",fp);
      	      	ecriremat(premiermembre,taillesysteme,fp);
         	   	ecriremessage("Second membre:",fp);
            		ecrirevect(secondmembre,taillesysteme,fp);
   			   	ecriremessage("Vecteur solution:",fp);
            		ecrirevect(vecteursolution,taillesysteme,fp);
                  ecriremessage("\nFichier genere par gauss.exe - ",fp);
                  ecriremessage("David ROUSSE, Igor APARICI -",fp);
               	fclose(fp);
            	}
            }
            else /* le systeme n'a pas de solution */
            	printf("\n !!! Le systeme n'a pas de solution !!!\n");

            attendre();
     		  	break;
	  	 	case 3:
         	/* methode du pivot partiel */
            clrscr();
            printf("\n Resolution du systeme par la methode ");
            printf("du PIVOT PARTIEL ...\n");

            resultat = pivotpartiel(premiermembre,secondmembre,vecteursolution,
            								taillesysteme);

            if(resultat)
            {
            	/* affichage du rsultat */
            	printf("\n Solution du systeme :\n");
            	affichervect(vecteursolution,taillesysteme);
               if(sortiefichier)
               {
               	/* ecriture des resultats dans un fichier */
               	printf("\n\n Ecriture des resultats sur le disque ...\n");
               	fp = recuperernomfic("partiel.txt");
               	ecriremessage("Resolution par la methode du pivot partiel\n",fp);
 		         	ecriremessage("Premier membre:",fp);
      	      	ecriremat(premiermembre,taillesysteme,fp);
         	   	ecriremessage("Second membre:",fp);
            		ecrirevect(secondmembre,taillesysteme,fp);
   			   	ecriremessage("Vecteur solution:",fp);
            		ecrirevect(vecteursolution,taillesysteme,fp);
                  ecriremessage("\nFichier genere par gauss.exe - ",fp);
                  ecriremessage("David ROUSSE, Igor APARICI -",fp);
               	fclose(fp);
               }
            }
            else /* le systeme n'a pas de solution */
            	printf("\n !!! Le systeme n'a pas de solution !!!\n");

            attendre();
     		  	break;
       	case 4:
         	/* comparaison des resultats */
            clrscr();

            /* recuperation du nom du fichier de sortie */
            if(sortiefichier)
            {
            	printf("\n\n Ecriture des resultats sur le disque ...\n");
               fp = recuperernomfic("compare.txt");
            }

            clrscr();
            printf("\n Comparaison des methodes de resolution ...");

         	/* calcul du temps d'excution par la mthode du pivt total */
            printf("\n\n *** Methode du PIVOT TOTAL ***");
            tdebut = clock(); /* time avant excution */
            resultat = pivottot(premiermembre,secondmembre,vecteursolution,
            									taillesysteme);
            tfin = clock(); /* time aprs excution */
            if(resultat)
            {
            	/* affichage de la dure du calcul */
	            printf("\n\n Temps d'execution : %8.6f secondes\n",
               													(tfin-tdebut)/CLK_TCK);
					/* affichage de la solution */
      	      printf("\n Solution du systeme :\n");
         	   affichervect(vecteursolution,taillesysteme);
               if(sortiefichier)
               {
               	/* ecriture des resultats dans un fichier */
               	ecriremessage("*** Methode du pivot total\n",fp);
                  ecriremessage("Temps d'execution: ",fp);
            		ecrirereel((tfin-tdebut)/CLK_TCK,fp);
   			   	ecriremessage("\nVecteur solution:",fp);
            		ecrirevect(vecteursolution,taillesysteme,fp);
               }
            }

         	/* calcul du temps d'excution par la mthode du pivt de Gauss */
            printf("\n\n *** Methode du PIVOT de Gauss-Jordan ***");
            tdebut = clock(); /* time avant excution */
            resultat = pivotgauss(premiermembre,secondmembre,vecteursolution,
            									taillesysteme);
            tfin = clock(); /* time aprs excution */
            if(resultat)
            {
            	/* affichage de la dure du calcul */
	            printf("\n\n Temps d'execution : %8.6f secondes\n",
               												  	(tfin-tdebut)/CLK_TCK);
					/* affichage de la solution */
      	      printf("\n Solution du systeme :\n");
         	   affichervect(vecteursolution,taillesysteme);
               if(sortiefichier)
               {
               	/* ecriture des resultats dans un fichier */
               	ecriremessage("*** Methode du pivot de Gauss-Jordan\n",fp);
                  ecriremessage("Temps d'execution: ",fp);
            		ecrirereel((tfin-tdebut)/CLK_TCK,fp);
   			   	ecriremessage("\nVecteur solution:",fp);
            		ecrirevect(vecteursolution,taillesysteme,fp);
               }
            }

         	/* calcul du temps d'excution lors de la mthode du pivt total */
            printf("\n\n *** Methode du PIVOT PARTIEL ***");
            tdebut = clock(); /* time avant excution */
            resultat = pivotpartiel(premiermembre,secondmembre,vecteursolution,
            									taillesysteme);
            tfin = clock(); /* time aprs excution */
            if(resultat)
            {
            	/* affichage de la dure du calcul */
	            printf("\n\n Temps d'execution : %d secondes\n",
               													(tfin-tdebut)/CLK_TCK);
					/* affichage de la solution */
      	      printf("\n Solution du systeme :\n");
         	   affichervect(vecteursolution,taillesysteme);
               if(sortiefichier)
               {
               	/* ecriture des resultats dans un fichier */
               	ecriremessage("*** Methode du pivot partiel\n",fp);
                  ecriremessage("Temps d'execution: ",fp);
            		ecrirereel((tfin-tdebut)/CLK_TCK,fp);
   			   	ecriremessage("\nVecteur solution:",fp);
            		ecrirevect(vecteursolution,taillesysteme,fp);
                  ecriremessage("\nFichier genere par gauss.exe - ",fp);
                  ecriremessage("David ROUSSE, Igor APARICI -",fp);
                  fclose(fp);
               }
            }

            attendre();
            break;
       	case 5:
         	/* calcul du determinant et du rang */
            clrscr();
            printf("\n *** Calcul du rang et du determinant du systeme ***\n");
            printf(" ***       par la methode du PIVOT PARTIEL       ***\n");
            rang = detrang(premiermembre,&determinant,taillesysteme);
            printf("\n Rang du systeme: %d\n", rang);
            if(rang==taillesysteme) /* le systme admet un dtermiant non nul */
              	printf("\n Determinant du systeme: %d\n", determinant);

	         attendre();
            break;
       	case 6:
         	/* calcul de la matrice inverse du systeme */
       		clrscr();
            printf("\n *** Calcul de la matrice inverse du systeme ***\n");
            printf(" ***       par la methode du PIVOT TOTAL     ***\n");

            calculinverse = inverse(premiermembre,matriceinverse,taillesysteme);

            if(calculinverse)
            {
            	/* affichage du rsultat */
            	printf("\n Matrice inverse du systeme :\n");
            	affichermat(matriceinverse,taillesysteme);
               if(sortiefichier)
               {
               	/* ecriture des resultats dans un fichier */
               	printf("\n\n Ecriture des resultats sur le disque ...\n");
               	fp = recuperernomfic("inverse.txt");
               	ecriremessage("Calcul de la matrice inverse",fp);
                  ecriremessage(" par la methode du pivot maximal ...\n",fp);
 		         	ecriremessage("Matrice du syteme:",fp);
      	      	ecriremat(premiermembre,taillesysteme,fp);
         	   	ecriremessage("Matrice inverse:",fp);
            		ecriremat(matriceinverse,taillesysteme,fp);
                  ecriremessage("\nFichier genere par gauss.exe - ",fp);
                  ecriremessage("David ROUSSE, Igor APARICI -",fp);
               	fclose(fp);
            	}
            }
            else /* le systeme n'a pas de solution */
            	printf("\n !!! Le systeme n'est pas inversible !!!\n");

            attendre();
            break;
       	case 7:
         	/* affichage du systme */
            clrscr();
         	printf("\nAffichage du premier membre:\n");
            affichermat(premiermembre,taillesysteme);
            attendre();
				printf("\nAffichage du deuxieme membre:\n");
            affichervect(secondmembre,taillesysteme);
         	printf("\n\nOccupation memoire RAM du systeme: %d octets\n\n"
            			,occupmemmat(taillesysteme)+occupmemvect(taillesysteme));

            attendre();
            break;
       	case 8:
            /* modification d'un coefficient */
            clrscr();
            modifierdonnee(premiermembre,secondmembre,taillesysteme);
            attendre();
            break;
       	case 9:
         	/* ecriture de toutes les donnes dans un fichier */
				clrscr();
            fp = recuperernomfic("sortie.txt");
            ecriremessage("Premier membre:",fp);
            ecriremat(premiermembre,taillesysteme,fp);
            ecriremessage("Second membre:",fp);
            ecrirevect(secondmembre,taillesysteme,fp);
            if(determinant!=-1) /* on verifie que le determinant est calcul */
            {
            	if(determinant)
               {
               	ecriremessage("Dterminant:",fp);
                 	ecrireentier(determinant,fp);
               }
               else
               	ecriremessage("Le systeme n'a pas de solution !",fp);
            }
            else
            {
            	ecriremessage("Attention, toutes les donnees n'etaient pas ",fp);
               ecriremessage("calculees \nlors de la generation du fichier!",
               																				 fp);
            }
            if(rang!=-1) /* on verifie que le rang a t calcul */
				{
            	ecriremessage("\nRang:",fp);
            	ecrireentier(rang,fp);
            }
            else
            {
            	ecriremessage("\nAttention, toutes les donnees n'etaient pas ",
               																				fp);
               ecriremessage("calculees \nlors de la generation du fichier!",
               																				fp);
            }
         	ecriremessage("\nOccupation memoire RAM du systeme: ",fp);
            ecrireentier(occupmemmat(taillesysteme)+occupmemvect(taillesysteme)
            																					,fp);
            ecriremessage(" octets\n",fp);

            if(calculinverse!=-1) /* on verifie que le rang a t calcul */
				{
	            ecriremessage("Matrice inverse:",fp);
   	         ecriremat(matriceinverse,taillesysteme,fp);
            }
            else
            {
            	ecriremessage("\nAttention, toutes les donnees n'etaient pas ",
               																				fp);
               ecriremessage("calculees \nlors de la generation du fichier!",
               																				fp);
            }

            ecriremessage("\nFichier genere par gauss.exe - ",fp);
            ecriremessage("David ROUSSE, Igor APARICI -",fp);

            fclose(fp);
            attendre();
            break;
       	case 10:
         	/* activation de l'ecriture des resultats dans un fichier */
           	clrscr();
            fflush(stdin);
            printf("\nL'ecriture des resultats dans un fichier est possible.");
           	printf("\nPour activer l'ecriture sur disque, taper _________ 1");
           	printf("\nPour desactiver l'ecriture sur disque, taper ______ 0");
            printf("\n\tVotre choix : ");
            scanf("%d",&sortiefichier);
            while((sortiefichier!=1)&&(sortiefichier!=0)) /* lit 0 ou 1 */
      		{
               fflush(stdin); /* vide le tampon */
               printf("\n\tChoix errone. Taper 1 ou 0 : ");
               scanf("%d",&sortiefichier);
	      	}
            if(sortiefichier)
            	printf("\nL'ecriture sur disque est active.\n");
            else
	            printf("\nL'ecriture sur disque est desactive.\n");

            attendre();
            break;
       	case 11:
         	/* nouvelle lecture des donnes */
           	clrscr();
            fflush(stdin); /* vide le tampon */

			   /* liberation memoire */
   			liberermat(premiermembre,taillesysteme);
   			liberervect(secondmembre);
   			liberervect(vecteursolution);
				liberermat(matriceinverse,taillesysteme);

			   /* lecture de la taille du systme  rsoudre */
			   taillesysteme = lecturetaille(nomfichier);

   			/* allocation dynamique de memoire */
   			premiermembre = allouermat(taillesysteme);
			   secondmembre = allouervect(taillesysteme);
			   vecteursolution = allouervect(taillesysteme);
			   matriceinverse = allouermat(taillesysteme);

   			/* lecture des donnees */
   			lecturedonnees(premiermembre,secondmembre,taillesysteme,nomfichier);

            attendre();
            break;
         default :
         	printf ("\n !!! Choix errone. Recommencez SVP !!!");
            attendre();
      }
   }
   while(choix);

   /* liberation memoire */
   liberermat(premiermembre,taillesysteme);
   liberervect(secondmembre);
   liberervect(vecteursolution);
	liberermat(matriceinverse,taillesysteme);

   /* message du fin */
   messagefin();

   return;

}

