#ifndef _PERSO_H
#define _PERSO_H

/**************************************************************************
*
* Nom du projet     : Gauss
* Objet 				  : Fichier de prototypes personnels pour le projet Gauss
*
***************************************************************************
*
* Rpertoire                : gauss\include
* Nom du fichier            : perso.h
* Nom du fichier d'analyse  : suivi/suivi.doc
* Auteur                    : Igor APARICI - David ROUSSE
* Date de creation          : 06 / 12 /1999
* Date de mise a jour       :
* Valide par                : Igor APARICI
* Date de validation        : 11 / 01 / 2000
* Indice du module          : 0
*
***************************************************************************
*/

#include <stdio.h>

#define true 1
#define false 0

/* fonctions de utils.c */
void menu(void);
void attendre(void);
void messagedebut(void);
void messagefin(void);
void erreur(char*);

/* fonctions de mem.c */
double **allouermat(int);
double *allouervect(int);
double **allouer(int,int);
void liberermat(double **, int);
void liberervect(double *);
int occupmemmat(int);
int occupmemvect(int);

/* fonctions de lecture.c */
int lecturetaille(char *);
void lecturedonnees(double **, double *, int, char *);
void modifierdonnee(double **, double *, int);

/* fonctions de ecriture.c */
void affichermat(double **,int);
void affichervect(double *,int);
void ecriremat(double **, int, FILE *);
void ecrirevect(double *, int, FILE *);
void ecriremessage(const char *, FILE *);
void ecrireentier(const int, FILE *);
void ecrirereel(const float, FILE *);
FILE *recuperernomfic(char *);

/* fonction de pivotpart.c */
int pivotpartiel(double ** ,double * ,double *, int);

/* fonction de pivotgauss.c */
int pivotgauss(double ** ,double * ,double *, int);

/* fonction de pivotot.c */
int pivottot(double **, double *, double *, int );

/* fonction de inverse.c */
int inverse(double **, double **, int);

/* fonction de detrang.c */
int detrang(double **, int *, int);

#endif
