/**************************************************************************
*
* Nom du projet     : Gauss
* Objet 				  : Rsolution d'un systme linaire  n quations
*							  n inconnues. Module d'acquisition des donnes sur
*							 disque dur.
*
***************************************************************************
*
* Rpertoire                : gauss\lib
* Nom du fichier            : lecture.c
* Nom du fichier d'analyse  : suivi/suivi.doc
* Auteur                    : David ROUSSE
* Date de creation          : 13 / 12 /1999
* Date de mise a jour       :
* Valide par                : David ROUSSE
* Date de validation        : 11 / 01 / 2000
* Indice du module          : 0
*
***************************************************************************
*
***************************************************************************
*/

#include "perso.h"
#include <stdio.h>
#include <ctype.h>
#include <string.h>

/************************************************************
* NOM : lecturetaille
* INDICE : 0
* AUTEUR : David Rousse
* DESCRIPTION :    lit la taille du systeme lineaire  rsoudre
*
* SYNTAXE : int taille = lecturetaille(nomfichier);
************************************************************
*/
int lecturetaille(char *nomfic)
{
	FILE *fp;
   char ch, tampon[201];
   int taille=0, retour;

   /* demande du nom de fichier en entre */
   printf("\n Entrez le nom du fichier (nom et extension).");
   printf("\n Note: si aucun nom de fichier entre, le programme essaiera");
   printf("\n de lire donnees.txt dans le repertoire courant.");
   printf("\n\t Nom fichier: ");
   gets(nomfic);

   /* ouverture du fichier */
   fp = fopen(nomfic, "r");
   if(fp == NULL) /* nom de fichier de donnes par dfaut */
   	fp = fopen("donnees.txt", "r");
   	if(fp == NULL) /* arret du programme */
      	erreur("\nImpossible d'ouvrir le fichier !!!");

   /* limination des commentairtes dans le fichier */
   do
   {
      ch = (char)getc(fp);
      if(ch==EOF)
      	erreur("\nFicher en entre vide !!!");
   }
   while(!isdigit(ch));
   ungetc(ch,fp); /* repositionnement sur le chiffre prcdent */

   /* compter le nombre de ligne pour dterminer la taille */
   /* du systme linaire  traiter								  */
   while(fgets(tampon, 200, fp))
   	if(*tampon!='\n') taille++;

   /* vrification que la matrice du systme est carre */
   retour = taille/2;
   if((2*retour)!=taille)
   	erreur("\nLe systme entre n'est pas  n quations  n inconnues.");

   /* fermeture fichier de donnes */
   fclose(fp);

   return retour;

}

/************************************************************
* NOM : lecturedonnees
* INDICE : 0
* AUTEUR : David Rousse
* DESCRIPTION :    lit le systeme lineaire  rsoudre
*
* SYNTAXE : lecturedonnees(matrice,secondmembre,taille,nomfichier);
************************************************************
*/
void lecturedonnees(double **matrice, double *secondmembre, int taille, char *nomfic)
{

	FILE *fp;
   int i, j;
   char ch;

   /* ouverture du fichier */
   fp = fopen(nomfic, "r");
   if(fp == NULL) /* nom de fichier de donnes par dfaut */
   	fp = fopen("donnees.txt", "r");
		   if(fp == NULL) /* arret du programme */
   			erreur("\nImpossible d'ouvrir le fichier !!!");

   /* limination des commentairtes dans le fichier */
   do
   {
      ch = (char)getc(fp);
      if(ch==EOF)
      	erreur("\nFicher en entre vide !!!");
   }
   while(!isdigit(ch));
   ungetc(ch,fp); /* repositionnement sur le chiffre prcdent */

   /* lecture du 1 membre */
	for(i=0;i<taille;i++)
   	/* lecture d'une ligne */
      for(j=0;j<taille;j++)
      	fscanf(fp, "%lf", &matrice[i][j]);


   /* lecture du 2 membre */
   for(i=0;i<taille;i++)
	  	fscanf(fp, "%lf", &secondmembre[i]);

   /* fermeture fichier de donnes */
   fclose(fp);

}

/************************************************************
* NOM : modifierdonnee
* INDICE : 0
* AUTEUR : Igor APARICI - David Rousse
* DESCRIPTION :    modifie un coefficient du systeme
*
* SYNTAXE : modifierdonnee(matrice,secondmembre,taille);
************************************************************
*/
void modifierdonnee(double **mat, double *vect, int taille)
{
   int lig, col;
   double donnee;

   /* lecture des indices du coefficient */
   fflush(stdin); /* vide le tampon */
  	printf("\n Coordonnees du coefficient a modifier...");
   printf("\n Entrer la ligne et la colonne separes par un espace: ");
   scanf("%d %d", &lig, &col);

   fflush(stdin); /* vide le tampon */
	if(col>taille) /* modification du second membre */
   {
   	printf("\n Modification du second membre...");
      printf("\n Entrer la nouvelle donnee: ");
		scanf("%lf", &donnee);
      /* stockage dans second membre */
      if(lig<=taille) /* coordonnee correcte */
      	vect[lig-1] = donnee;
   }
   else
   	/* modification de la matrice */
      if(lig<=taille) /* coordonnee correcte */
      {
	   	printf("\n Modification du premier membre...");
   	   printf("\n Entrer la nouvelle donnee: ");
			scanf("%lf", &donnee);
      	/* stockage dans second membre */
      	mat[lig-1][col-1] = donnee;
      }
}
